<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>hydra-dict</title>
    <script src="https://unpkg.com/hydra-synth"></script>
</head>

<body>

    <script>

        const hydraCanvas = document.createElement("CANVAS");
        hydraCanvas.width = window.innerWidth / 2.;
        hydraCanvas.height = window.innerHeight / 2.;
        var opt = {
            canvas: hydraCanvas, // canvas element to render to. If none is supplied, a canvas will be created and appended to the screen

            // width:window.innerWidth,// defaults to canvas width when included, 1280 if not

            // height: window.innerHeightnoise,// defaults to canvas height when included, 720 if not

            autoLoop: true, // if true, will automatically loop using requestAnimationFrame.If set to false, you must implement your own loop function using the tick() method (below)

            makeGlobal: true, // if false, will not pollute global namespace (note: there are currently bugs with this)

            detectAudio: false, // recommend setting this to false to avoid asking for microphone

            numSources: 4, // number of source buffers to create initially

            numOutputs: 4, // number of output buffers to use. Note: untested with numbers other than 4. render() method might behave unpredictably

            extendTransforms: [], // An array of transforms to be added to the synth, or an object representing a single transform

            precision: null,  // force precision of shaders, can be 'highp', 'mediump', or 'lowp' (recommended for ios). When no precision is specified, will use highp for ios, and mediump for everything else.

            pb: null, // instance of rtc-patch-bay to use for streaming
        }


        const hydra = new Hydra(opt)

        document.body.appendChild(hydraCanvas);
        const dict = {
            "osc": (a = 20, b = .1, c = 0) => osc(a, b, c),
            "noise": (a = 20, b = .1) => noise(a, b),
            "gradient": (a = 20, b = .1) => gradient(),
            "shape": (a = 8, b = .1, c = .5) => shape(a, b),
            "diff": (a, b, n = 1) => a.diff(b),
            "add": (a, b, n = 1) => a.add(b),
            "blend": (a, b, n = 1) => a.blend(b),
        }

        var valor = "gradient"
        //esto en un futuro de no poder avanzar con el objeto pasaria a ser un array de jsons y un for con algunos if 
        var listado = ["osc", "noise", "shape"] 
        var otraLista = ["add", "blend", "diff"] //solo de prueba lo ideal seria un json x cada conjunto?
        //generar un metodo para substraer elementos a listado

        //inicio de cadena de func //esta var y listado deberian ser globales
        var sumFunc = dict[valor]();//osc();

        //este bucle seria remplazado con otro desde un obj ensamblador de func
        for (var i = 0; i < listado.length; i++) {
            sumFunc = dict[otraLista[i]](sumFunc, dict[listado[i]](4, 0.1,));
            // sumFunc = dict["diff"](sumFunc, dict[listado[i]](4, 0.1,));
        }

        //resultante 
        // var tiempo =0;// Date.now()*0.001;
        // setInterval(() => {
        //     tiempo+=0.0001;
        //     console.log(tiempo)
        //     console.log("tic")
        //     sumFunc.rotate(Math.PI * Math.sin(tiempo)).out()
        // }, 100);

        sumFunc.out() 



        /*
        Variables a alimentar dict
        
                const source = {
                    "noise": (a = 20, b = .1, c = 0) => noise(a, b, c),
                    "voronoi": (a = 20, b = .1, c = 0.5) => voronoi(a, b, c),
                    "osc": (a = 20, b = .1, c = 0) => osc(a, b, c),
                    "shape": (a = 20, b = .1, c = 0) => shape(a, b, c),
                    "gradient": (a = 20, b = .1, c = 0) => gradient(a, b, c),
                    "src": (a = "o0") => src(a),
                    "solid": (a = 20, b = .1, c = 0) => solid(a, b, c),
                    "prev": (a = 20, b = .1, c = 0) => prev(a, b, c),
                }
                const geometria = {
                    "rotate": (a, b = .1, c = 0) => a.rotate(b, c),
                    "scale": (a = 20, b = .1, c = 0) => scale(a, b, c),
                    "pixelate": (a = 20, b = .1, c = 0) => pixelate(a, b, c),
                    "repeat": (a = 20, b = .1, c = 0) => repeat(a, b, c),
                    "repeatX": (a = 20, b = .1, c = 0) => repeatX(a, b, c),
                    "repeatY": (a = 20, b = .1, c = 0) => repeatY(a, b, c),
                    "kaleid": (a = 20, b = .1, c = 0) => kaleid(a, b, c),
                    "scroll": (a = 20, b = .1, c = 0) => scroll(a, b, c),
                    "scrollX": (a = 20, b = .1, c = 0) => scrollX(a, b, c),
                    "scrollY": (a = 20, b = .1, c = 0) => scrollY(a, b, c),
                }
                const col = {
                    "posterize": (a = 20, b = .1, c = 0) => posterize(a, b, c),
                    "shift": (a = 20, b = .1, c = 0) => shift(a, b, c),
                    "invert": (a = 20, b = .1, c = 0) => invert(a, b, c),
                    "contrast": (a = 20, b = .1, c = 0) => contrast(a, b, c),
                    "brightness": (a = 20, b = .1, c = 0) => brightness(a, b, c),
                    "luma": (a = 20, b = .1, c = 0) => luma(a, b, c),
                    "thresh": (a = 20, b = .1, c = 0) => thresh(a, b, c),
                    "color": (a = 20, b = .1, c = 0) => color(a, b, c),
                    "saturate": (a = 20, b = .1, c = 0) => saturate(a, b, c),
                    "hue": (a = 20, b = .1, c = 0) => hue(a, b, c),
                    "colorama": (a = 20, b = .1, c = 0) => colorama(a, b, c),
                }
                // "sum":(a = 20, b = .1, c = 0) =>  (a, b, c),
                // "r":(a = 20, b = .1, c = 0) =>  (a, b, c),
                // "g":(a = 20, b = .1, c = 0) =>  (a, b, c),
                // "b":(a = 20, b = .1, c = 0) =>  (a, b, c),
                // "a":(a = 20, b = .1, c = 0) =>  (a, b, c),
        
                const fusion = {
                    "add": (a, b, n = 1) => a.add(b),
                    "sub": (a, b, n = 1) => a.sub(b),
                    "layer": (a, b, n = 1) => a.layer(b),
                    "blend": (a, b, n = 1) => a.blend(b),
                    "mult": (a, b, n = 1) => a.mult(b),
                    "diff": (a, b, n = 1) => a.diff(b),
                    "mask": (a, b, n = 1) => a.mask(b),
                }
                const modul = {
                    "modulateRepeat": (a, b, n = 1) => a.modulateRepeat(b),
                    "modulateRepeatX": (a, b, n = 1) => a.modulateRepeatX(b),
                    "modulateRepeatY": (a, b, n = 1) => a.modulateRepeatY(b),
                    "modulateKaleid": (a, b, n = 1) => a.modulateKaleid(b),
                    "modulateScrollX": (a, b, n = 1) => a.modulateScrollX(b),
                    "modulateScrollY": (a, b, n = 1) => a.modulateScrollY(b),
                    "modulate": (a, b, n = 1) => a.modulate(b),
                    "modulateScale": (a, b, n = 1) => a.modulateScale(b),
                    "modulatePixelate": (a, b, n = 1) => a.modulatePixelate(b),
                    "modulateRotate": (a, b, n = 1) => a.modulateRotate(b),
                    "modulateHue": (a, b, n = 1) => a.modulateHue(b),
                }
                */
    </script>
</body>

</html>